Attribute VB_Name = "FileTimeService"
Option Explicit

'******************************************************************
Public Declare Function CreateFile _
                        Lib "kernel32" _
                        Alias "CreateFileA" _
                        (ByVal lpFileName As String, _
                         ByVal dwDesiredAccess As Long, _
                         ByVal dwSharedMode As Long, _
                         ByVal lpSecurityAttributes As Long, _
                         ByVal dwCreationDistribution As Long, _
                         ByVal dwFlagsAndAttributes As Long, _
                         ByVal hTemplateFile As Long) _
                        As Long

Public Const GENERIC_READ As Long = &H80000000
Public Const GENERIC_WRITE As Long = &H40000000

Public Const FILE_SHARE_READ As Long = 1&
Public Const FILE_SHARE_WRITE As Long = 2&
Public Const FILE_SHARE_DELETE As Long = 4&

Public Const CREATE_NEW As Long = 1&
Public Const CREATE_ALWAYS As Long = 2&
Public Const OPEN_EXISTING As Long = 3&
Public Const OPEN_ALWAYS As Long = 4&
Public Const TRUNCATE_EXISTING As Long = 5&

Public Const FILE_ATTRIBUTE_READONLY As Long = &H1&
Public Const FILE_ATTRIBUTE_HIDDEN As Long = &H2&
Public Const FILE_ATTRIBUTE_SYSTEM As Long = &H4&
Public Const FILE_ATTRIBUTE_ARCHIVE As Long = &H20&
Public Const FILE_ATTRIBUTE_NORMAL As Long = &H80&
Public Const FILE_ATTRIBUTE_TEMPORARY As Long = &H100&
Public Const FILE_ATTRIBUTE_COMPRESSED As Long = &H800&
Public Const FILE_ATTRIBUTE_OFFLINE As Long = &H1000&

Public Const FILE_FLAG_WRITE_THROUGH As Long = &H80000000
Public Const FILE_FLAG_OVERLAPPED As Long = &H40000000
Public Const FILE_FLAG_NO_BUFFERING As Long = &H20000000
Public Const FILE_FLAG_RANDOM_ACCESS As Long = &H10000000
Public Const FILE_FLAG_SEQUENTIAL_SCAN As Long = &H8000000
Public Const FILE_FLAG_DELETE_ON_CLOSE As Long = &H4000000
Public Const FILE_FLAG_BACKUP_SEMANTICS As Long = &H2000000
Public Const FILE_FLAG_POSIX_SEMANTICS As Long = &H1000000

'******************************************************************
Public Declare Function GetFileTime _
                        Lib "kernel32" _
                        (ByVal hFile As Long, _
                         lpCreationTime As FILETIME, _
                         lpLastAccessTime As FILETIME, _
                         lpLastWriteTime As FILETIME) _
                        As Long

'******************************************************************
Public Declare Function SetFileTime _
                        Lib "kernel32" _
                        (ByVal hFile As Long, _
                         lpCreationTime As FILETIME, _
                         lpLastAccessTime As FILETIME, _
                         lpLastWriteTime As FILETIME) _
                        As Long

'******************************************************************
Public Declare Function CloseHandle _
                        Lib "kernel32" _
                        (ByVal hObject As Long) _
                        As Long
'******************************************************************
Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type


