Attribute VB_Name = "FolderBrowse"
Option Explicit

Private Const MAX_PATH As Long = 260
Private Const MAX_PATH_HALF As Long = MAX_PATH \ 2

Private Type BROWSEINFO
    hwndOwner As Long
    pidlRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Private Declare Function SHBrowseForFolder _
                        Lib "shell32" _
                        (lpbi As BROWSEINFO) As Long

Private Const BIF_RETURNONLYFSDIRS As Long = &H1&
Private Const BIF_DONTGOBELOWDOMAIN As Long = &H2&
Private Const BIF_STATUSTEXT As Long = &H4&
Private Const BIF_RETURNFSANCESTORS As Long = &H8&

Private Const BIF_BROWSEFORCOMPUTER As Long = &H1000&
Private Const BIF_BROWSEFORPRINTER As Long = &H2000&
Private Const BIF_BROWSEINCLUDEFILES As Long = &H4000&

Private Declare Function SHGetPathFromIDList _
                        Lib "shell32" _
                        (ByVal pidl As Long, _
                         ByVal pszPath As String) _
                        As Long

Private Declare Function PostMessage _
                        Lib "user32" _
                        Alias "PostMessageA" _
                        (ByVal hwnd As Long, _
                         ByVal Msg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) _
                        As Long

Private Declare Function PostMessageString _
                        Lib "user32" _
                        Alias "PostMessageA" _
                        (ByVal hwnd As Long, _
                         ByVal Msg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As String) _
                        As Long

Public Function SelectDirectory(ByVal hwnd As Long, _
                                Optional strPathInitialUNICODE As String, _
                                Optional strTitleUNICODE As String) As String
    Const TITLE_DEFAULT As String = "Select A Folder"
    
    Dim pbi As BROWSEINFO, pidl As Long
    Dim strDisplayNameANSI As String
    Dim lngRC As Long
    
    Dim strTitleANSI As String, strPathInitialANSI As String
    Dim mstrPathSelectedUNICODE As String
    
    On Error GoTo ErrorHandler
    
    
    strDisplayNameANSI = String$(MAX_PATH_HALF, vbNullChar)
    
    If strTitleUNICODE = "" Then
        strTitleANSI = StrConv(TITLE_DEFAULT, vbFromUnicode)
    Else
        strTitleANSI = StrConv(strTitleUNICODE, vbFromUnicode)
    End If
        
    If strPathInitialUNICODE <> "" Then
        If Right(strPathInitialUNICODE, 1) = "\" Then _
            strPathInitialUNICODE = Left(strPathInitialUNICODE, _
                                            Len(strPathInitialUNICODE) - 1)
        strPathInitialANSI = StrConv(strPathInitialUNICODE, vbFromUnicode)
    Else
        strPathInitialANSI = ""
    End If
    
    With pbi
        .hwndOwner = hwnd
        .pidlRoot = 0
        .pszDisplayName = StrPtr(strDisplayNameANSI)
        .lpszTitle = StrPtr(strTitleANSI)
        .ulFlags = BIF_BROWSEFORCOMPUTER
        .lpfn = 0
        .lParam = 0
    End With

    pidl = SHBrowseForFolder(pbi)
    
    If pidl = 0 Then
        SelectDirectory = ""
    Else
        mstrPathSelectedUNICODE = String$(MAX_PATH_HALF, vbNullChar)
        lngRC = SHGetPathFromIDList(pidl, mstrPathSelectedUNICODE)
        SelectDirectory = Left(mstrPathSelectedUNICODE, _
                               InStr(mstrPathSelectedUNICODE, vbNullChar) - 1)
    End If

    Exit Function
    
ErrorHandler:
    SelectDirectory = ""
    
End Function
