Attribute VB_Name = "SysApiFunc"
Option Explicit
Private Const MAX_PATH As Long = 260

Private Declare Function GetWindowsDirectoryAPI _
                            Lib "kernel32" _
                            Alias "GetWindowsDirectoryA" _
                        (ByVal lpBuffer As String, _
                            ByVal nSize As Long) _
                        As Long

Private Declare Function GetSystemDirectoryAPI _
                            Lib "kernel32" _
                            Alias "GetSystemDirectoryA" _
                        (ByVal lpBuffer As String, _
                            ByVal nSize As Long) _
                        As Long

Private Declare Function GetUserNameAPI _
                            Lib "advapi32" _
                            Alias "GetUserNameA" _
                        (ByVal lpBuffer As String, _
                            nSize As Long) _
                        As Long

Public Function GetSystemDirectory() As Variant
    Dim strbuffer As String
    Dim lngRetCode As Long
    
    strbuffer = String$(MAX_PATH, vbNullChar)
    lngRetCode = GetSystemDirectoryAPI(strbuffer, MAX_PATH)
    
    If lngRetCode > MAX_PATH Or lngRetCode = 0 Then
        GetSystemDirectory = Null
    Else
        GetSystemDirectory = Left(strbuffer, lngRetCode)
    End If
End Function

Public Function GetWindowsDirectory() As Variant
    Dim strbuffer As String
    Dim lngRetCode As Long
    
    strbuffer = String$(MAX_PATH, vbNullChar)
    lngRetCode = GetWindowsDirectoryAPI(strbuffer, MAX_PATH)
    
    If lngRetCode > MAX_PATH Or lngRetCode = 0 Then
        GetWindowsDirectory = Null
    Else
        GetWindowsDirectory = Left(strbuffer, lngRetCode)
    End If
End Function

Public Function GetUserName() As Variant
    Dim strbuffer As String
    Dim lngBufferLength
    Dim lngRetCode As Long
    
    For lngBufferLength = 32 To 256 Step 16
        strbuffer = String$(lngBufferLength, vbNullChar)
        lngRetCode = GetUserNameAPI(strbuffer, lngBufferLength)
    
        If lngRetCode <> 0 Then
            GetUserName = Left(strbuffer, lngBufferLength - 1)
            Exit Function
        End If
    Next
    
    GetUserName = Null

End Function

